---
title: CompositionEvent.data
slug: Web/API/CompositionEvent/data
tags:
  - API
  - CompositionEvent
  - Property
  - Reference
  - data
---
<p>{{APIRef("DOM Events")}}</p>

<p>The <code><strong>data</strong></code> read-only property of the {{domxref("CompositionEvent")}} interface returns the characters generated by the input method that raised the event; its exact nature varies depending on the type of event that generated the <code>CompositionEvent</code> object.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"> myData = CompositionEvent.data</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} representing the event data:</p>

<ul>
 <li>For <code>compositionstart</code> events, this is the currently selected text that will be replaced by the string being composed. This value doesn't change even if content changes the selection range; rather, it indicates the string that was selected when composition started.</li>
 <li>For <code>compositionupdate</code>, this is the string as it stands currently as editing is ongoing.</li>
 <li>For <code>compositionend</code> events, this is the string as committed to the editor.</li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM3 Events','#dom-compositionevent-data','data')}}</td>
   <td>{{Spec2('DOM3 Events')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CompositionEvent.data")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("CompositionEvent")}}</li>
</ul>
